#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <sys/types.h>
#include <errno.h>



static int hash_buf(char *src, char *dst, uint32_t iv, int len, int hash_id)
{
        unsigned char digest[20];
	unsigned char *newbuf;
	
	
	newbuf=malloc(len+4);
        iv = htonl(iv);
        memcpy(newbuf, &iv, 4);
        memcpy(newbuf+4,src,len);
        printf("len=%d\n",len);
        
        if (hash_id==1)
        {
    	    hash_sha1(newbuf, dst, len+4);
        }
        free(newbuf);
        return 0;
}

static int get_algo_dlen(int hash_id)
{
if (hash_id==1) return 20;

}


static int map_name(const char *name)
{
    if (memcmp(name,"sha1")) return 1;
}

static void XORblock(char const *src1, char const *src2, char *dst, size_t n)
{
	size_t j;

	for(j = 0; j < n; ++j)
		dst[j] = src1[j] ^ src2[j];
}


static int diffuse(char *src, char *dst, size_t size, int hash_id)
{
	unsigned int digest_size = get_algo_dlen(hash_id);
	unsigned int i, blocks, padding;

	blocks = size / digest_size;
	padding = size % digest_size;

	for (i = 0; i < blocks; i++)
		if(hash_buf(src + digest_size * i,
			    dst + digest_size * i,
			    i, digest_size, hash_id))
			return 1;

	if(padding)
		if(hash_buf(src + digest_size * i,
			    dst + digest_size * i,
			    i, padding, hash_id))
			return 1;

	return 0;
}


int AF_merge(char *src, char *dst, size_t blocksize, unsigned int blocknumbers, const char *hash)
{
	unsigned int i;
	char *bufblock;
	int r = -EINVAL;
	int hash_id;

	if (!(hash_id = map_name(hash)))
		return -EINVAL;

	if((bufblock = calloc(32, 1)) == NULL) return -ENOMEM;

	memset(bufblock,0,blocksize);
	for(i=0; i<blocknumbers-1; i++) {
		XORblock(src+(blocksize*i),bufblock,bufblock,blocksize);
		if(diffuse(bufblock, bufblock, blocksize, hash_id))
			goto out;
	}
	XORblock(src + blocksize * i, bufblock, dst, blocksize);
	r = 0;
out:
	free(bufblock);
	return 0;
}

