/* wordpress.c
 *
 * hashkill - a hash cracking tool
 * Copyright (C) 2010 Milen Rangelov <gat3way@gat3way.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

//#define _XOPEN_SOURCE
#include <crypt.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "plugin.h"
#include "err.h"
#include "hashinterface.h"

extern char *pacrypt_private (const char *key, const char *salt, char *out);



char * hash_plugin_summary(void)
{
    return("wordpress \tWordpress hashes plugin");
}


char * hash_plugin_detailed(void)
{
    return("wordpress - Wordpress hashes plugin\n"
	    "------------------------\n"
	    "Use this module to crack wordpress passwords\n"
	    "Input should be in form: \'user:hash\'.\n"
	    "Known software that uses this password hashing method:\n"
	    "Wordpress\n"
	    "\nAuthor: Milen Rangelov <gat3way@gat3way.eu>\n");
}


hash_stat hash_plugin_parse_hash(char *hashline, char *filename)
{
    char username[HASHFILE_MAX_LINE_LENGTH];
    char salt[HASHFILE_MAX_LINE_LENGTH];
    char line[HASHFILE_MAX_LINE_LENGTH];
    char line2[HASHFILE_MAX_LINE_LENGTH];

    char *temp_str, *temp_str2 = NULL, *temp_str3 = NULL;
    
    if (!hashline) return hash_err;
    
    if (strlen(hashline)<2) return hash_err;
    
    snprintf(line, HASHFILE_MAX_LINE_LENGTH-1, "%s", hashline);
    strcpy(username, strtok(line, ":"));
    temp_str = strtok(NULL,":");
    if (temp_str) 
    {
	strcpy(line2, temp_str);
	temp_str2 = strtok(line2,"$");
	if (!temp_str2) return hash_err;
	strcpy(temp_str, temp_str2);
	temp_str2 = strtok(NULL,"$");
	if (!temp_str2) return hash_err;
	temp_str3=alloca(30);
	memcpy(temp_str3, temp_str2, 9);
	snprintf(salt, HASHFILE_MAX_LINE_LENGTH-1, "$%s$%s", temp_str, temp_str3);
    }

    /* No hash provided at all? */
    if (strcmp(username,hashline)==0)
    {
	return hash_err;
    }
    /* ensure they aren't smashing the heap?!?*/
    (void)hash_add_username(username);
    (void)hash_add_salt(salt);
    sprintf(line,"$P$%s",temp_str2);
    (void)hash_add_hash(line, 0);

    (void)hash_add_salt2("");

    return hash_ok;
}


hash_stat hash_plugin_check_hash(const char *hash, const char *password, const char *salt,  char *salt2, const char *username)
{
    char hash2[HASHFILE_MAX_LINE_LENGTH];


    switch (*(salt+1))
    {
	case 'P': 
	    strcpy(hash2, pacrypt_private(password, salt, hash2));
	    break;
	default: return hash_err;
    }
    hash2[HASHFILE_MAX_LINE_LENGTH-1] = 0;
    if (fastcompare(hash2,hash,strlen(hash))==0) return hash_ok;
    else return hash_err;
}


int hash_plugin_hash_length(void)
{
    return 0;
}

int hash_plugin_is_raw(void)
{
    return 0;
}

int hash_plugin_is_special(void)
{
    return 0;
}
